package com.codigoparallevar.minicards;

import android.content.Context;
import android.content.SharedPreferences;
import android.view.View;

import static android.content.Context.MODE_PRIVATE;

public class ConfigManager {
    private final Context context;
    private static final String TOKEN_KEY = "PROGRAMAKER_API_TOKEN";
    private static final String PREFERENCES_NAME = "MINICARDS_PREFERENCES";

    public ConfigManager(Context ctx) {
        this.context = ctx;
    }

    public void setToken(String token) {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        SharedPreferences.Editor edit = preferences.edit();

        edit.putString(TOKEN_KEY, token);
        edit.commit();
    }

    public String getToken() {
        SharedPreferences preferences = this.context.getSharedPreferences(PREFERENCES_NAME, MODE_PRIVATE);
        if (!preferences.contains(TOKEN_KEY)) {
            return null;
        }
        else {
            return preferences.getString(TOKEN_KEY, null);
        }
    }
}
