package com.codigoparallevar.minicards.ui_helpers;

import android.os.AsyncTask;
import android.util.Log;

import com.codigoparallevar.minicards.types.functional.Consumer;
import com.codigoparallevar.minicards.types.functional.Producer;
import com.codigoparallevar.minicards.types.functional.Tuple2;

public class GetAsync<T> extends AsyncTask<Tuple2<Producer<T>, Consumer<T>>,
        Void,
        Tuple2<T, Consumer<T>>> {

    @Override
    protected Tuple2<T, Consumer<T>> doInBackground(Tuple2<Producer<T>, Consumer<T>>... data) {
        try {
            return new Tuple2<>(data[0].item1.get(), data[0].item2);
        }
        catch (Exception ex) {
            Log.e("GetAsync", ex.toString());
            return new Tuple2<>(null, data[0].item2);
        }
    }

    @Override
    protected void onPostExecute(Tuple2<T, Consumer<T>> result) {
        result.item2.apply(result.item1);
    }
}
